# This data was obtained from the measure.elf program running
# on our FPGA platform (see ml505/measure.log)


# Problem set up...
LOCAL_MEMORY_SIZE = 2048
CLOCK_CYCLE = 10e-9
TRANSITION_CODE_OVERHEAD = 16       # S^RT in bytes
BLOCK_SIZE = 16



# Constants determined through 100000 tests:
SAVE_PER_BLOCK = 10e-9
BRT_SPM = 320e-9
SAVE_OVERHEAD = 630e-9
RESTORE_OVERHEAD = 570e-9
BRT_CACHE = 310e-9
# measure_region_change
# C^load_1 = BRT^spm = 320ns
TRANSITION_WCET_OVERHEAD = 150e-9
# cs_measure
# number of tasks 15
CS1 = 9090e-9
CS2 = 5500e-9


def Save(n):
    return SAVE_PER_BLOCK * n + SAVE_OVERHEAD
    
def Load(n):
    return (BRT_SPM * n) + TRANSITION_WCET_OVERHEAD

def Restore(n):
    return BRT_SPM * n + RESTORE_OVERHEAD

