#!/usr/bin/python

import sys

logname = sys.argv[1]

running = dict()
timings = dict()
preempts = dict()
old_timestamp = 0
idle = "idle"
task_stack = [idle]
running[idle] = 0
preempts[idle] = 0

for line in file(logname):
    fields = line.split()
    if len(fields) < 3:
        continue

    try:
        timestamp = int(fields[0], 16)
        tag_id = fields[1]
        parameter = int(fields[2], 16)
    except ValueError:
        continue

    fields = fields[3:]
    delta = timestamp - old_timestamp
    old_timestamp = timestamp

   
    cur_task = task_stack[-1]
    running[cur_task] += delta

    if tag_id == "TASK_START":
        name = fields[0]
        assert not running.has_key(name)
        running[name] = 0
        preempts[name] = 0
        task_stack.append(name)
        preempts[cur_task] += 1

    elif tag_id == "TASK_END":
        name = fields[0]
        assert running.has_key(name)
        check = task_stack.pop()
        assert check == name

        timer = running[name]
        del running[name]
        if not timings.has_key(name):
            timings[name] = []

        timings[name].append((timer, preempts[name]))

timings[idle] = [(timer, preempts[idle])]
timings = timings.items()
timings.sort()

for (name, timer_list) in timings:
    timer_list.sort()
    print name, len(timer_list)
    print '  ', timer_list[0], timer_list[len(timer_list) / 2], timer_list[-1]



