

def calc_wu(fname, index = 3):
    total = 0
    counters = dict()
    max_tasks = 0
    for line in file(fname):
        fields = line.split()
        u = float(fields[1])
        for i in xrange(2, len(fields)):
            counters[i] = counters.get(i, 0) + (float(fields[i]) * u)

        max_tasks = max(float(fields[2]), max_tasks)
        total += max_tasks * u

    return counters[index] / total

if __name__ == "__main__":
    srpd = calc_wu("experiment/section4/good.csv", index = 3)

    exsrpd = calc_wu("experiment/section4/good.csv")
    exloblock = calc_wu("experiment/section4/loblock.csv")

    out = file("res/post.tex", "wt")
    out.write(r"""
\newcommand{\excrpd}{$%1.3f$}""" %
            calc_wu("experiment/section4/good.csv", index = 2))
    out.write(r"""
\newcommand{\exsrpd}{$%1.3f$} %% %1.9f""" % (exsrpd, exsrpd))
    out.write(r"""
\newcommand{\exsrpdac}{$%1.4f$} %% %1.9f""" % (exsrpd, exsrpd))
    out.write(r"""
\newcommand{\exreal}{$%1.3f$}""" %
            calc_wu("experiment/section4/real.csv"))
    out.write(r"""
\newcommand{\exloblockac}{$%1.4f$}  %% %1.9f""" % (exloblock, exloblock))
    out.write(r"""
\newcommand{\exbrtbest}{$%1.3f$}""" %
            calc_wu("experiment/section5_2/brt100.ideal.csv"))
    out.write(r"""
\newcommand{\exbrtbad}{$%1.3f$}""" %
            calc_wu("experiment/section5_2/brt110.ideal.csv"))
    out.write(r"""
\newcommand{\exbrtbadder}{$%1.3f$}""" %
            calc_wu("experiment/section5_2/brt120.ideal.csv"))
    out.write(r"""
%% check = %1.3f""" %
            calc_wu("experiment/section5_2/brt103.ideal.csv"))
    out.write("\n\n\n")
    out.close()


